#include "BetheBlochFunction.hh"

double BetheBlochFunction(double *rig,double *par)
{
    double charge=double(fabs(par[3]));
    double m=double(par[4]);//mass
    double calib=par[5];//calibFactor
    double satura=par[6];//saturation

    double prefactor=par[0];
    double postfactor=par[1];
    double mFactor=par[2];
    double myValue;
    double b2, gb2;
    double myDedx;



    myValue =5059.0;


    gb2=(rig[0]*charge/m)*(rig[0]*charge/m);
        
    if (gb2 > 0.0) b2=1.0/(1.0 + 1.0/gb2);
    else return 0.0;
    if (myValue*gb2<=1.) return 0; //VP non physical region
	  myDedx=calib*charge*charge*(1.0/TMath::Power(b2,prefactor))*(TMath::Power(TMath::Log(myValue*gb2),0.7) - postfactor*b2 )- mFactor;
    if (myDedx > satura) myDedx=satura;   

    return myDedx;

}
