/* ftpcClusterPars.h */
/* This file was made by the idl compiler "stic". Do not edit.
** This was generated for version '(unspecified)'
** Instead, edit the source idl file and then re-run the compiler.
** For help, type contact Craig Tull or Herb Ward. */
/* COMMENTS FROM IDL FILE:
    ftpcClusterPars

  Table: ftpcClusterPars

       description:     FTPC Cluster Finder run and code parameters    FTPC Cluster Finder run and code parameters



 code parameters
 run parameters
 */
#ifndef FTPCCLUSTERPARS_H
#define FTPCCLUSTERPARS_H
#define FTPCCLUSTERPARS_SPEC \
"struct ftpcClusterPars { \
	long gaussFittingFlags; \
	long minimumClusterMaxADC; \
	long numberOfDriftSteps; \
	long orderOfDiffusionErrors; \
	float padDiffusionErrors[3]; \
	float timeDiffusionErrors[3]; \
	float lorentzAngleFactor; \
	float padBadFitError; \
	float timeBadFitError; \
	float padUnfoldError; \
	float timeUnfoldError; \
	float padFailedFitError; \
	float timeFailedFitError; \
	float padCutoffClusterError; \
	float timeCutoffClusterError; \
	float padSaturatedClusterError; \
	float timeSaturatedClusterError; \
	float twoPadWeightedError; \
	float twoPadGaussError; \
	float threePadWeightedError; \
	float threePadGaussError; \
	float zDirectionError; \
	long maxNumSequences; \
	long maxNumSeqPeaks; \
	long maxNumPeaks; \
	long maxNumCUC; \
	long maxLoops; \
	long maxFastLoops; \
	float unfoldLimit; \
	float unfoldFailedLimit; \
	float normalizedNowPressure; \
	float adjustedAirPressureWest; \
	float adjustedAirPressureEast; \
	float gasTemperatureWest; \
	float gasTemperatureEast; \
};"
typedef struct ftpcClusterPars_st {
	int gaussFittingFlags; /* 2=time gaussfit, 3=all gaussfit */
	int minimumClusterMaxADC; /* cluster minimum peakheight */
	int numberOfDriftSteps; /* # of steps in drift map integration */
	int orderOfDiffusionErrors; /* order of diffusion errors */
	float padDiffusionErrors[3]; /* function of driftlength up to 2nd order*/
	float timeDiffusionErrors[3]; /* function of driftlength up to 2nd order*/
	float lorentzAngleFactor; /* lorentz angle correction factor */
	float padBadFitError; /* additional error for bad-fit clusters*/
	float timeBadFitError; /* additional error for bad-fit clusters*/
	float padUnfoldError; /* additional error for unfolded clusters*/
	float timeUnfoldError; /* additional error for unfolded clusters*/
	float padFailedFitError; /* additional error for failed-fit clusters*/
	float timeFailedFitError; /* additional error for failed-fit clusters*/
	float padCutoffClusterError; /* additional error for cut-off clusters*/
	float timeCutoffClusterError; /* additional error for cut-off clusters*/
	float padSaturatedClusterError; /* additional error for saturated clusters*/
	float timeSaturatedClusterError; /* additional error for saturated clusters*/
	float twoPadWeightedError; /* additional error 2-pad-cluster, weighted mean */
	float twoPadGaussError; /* additional error 2-pad-cluster, gaussfit */
	float threePadWeightedError; /* additional error 3-pad-cluster, weighted mean */
	float threePadGaussError; /* additional error 3-pad-cluster, gaussfit */
	float zDirectionError; /* parameter for error in z-direction */
	int maxNumSequences; /* max number of used sequences (not used yet) */
	int maxNumSeqPeaks; /* max number of peaks per sequence */
	int maxNumPeaks; /* max number of unfolded peaks per cluster */
	int maxNumCUC; /* max number of cluster under construction (not used yet) */
	int maxLoops; /* max loopnumber in unfolding */
	int maxFastLoops; /* max loopnumber in fast unfolding */
	float unfoldLimit; /* accuracy of unfolding */
	float unfoldFailedLimit; /* limit for failed unfolding */
	float normalizedNowPressure; /* normalized air pressure (in hPa) */
	float adjustedAirPressureWest; /* temperature adjusted air pressure for FTPC West */
	float adjustedAirPressureEast; /* temperature adjusted air pressure for FTPC East */
	float gasTemperatureWest; /* temperature of gas in FTPC West */
	float gasTemperatureEast; /* temperature of gas in FTPC East */
} FTPCCLUSTERPARS_ST;
#endif /* FTPCCLUSTERPARS_H */
