#!/bin/sh
#
# Author: Nikita Ermakov (coffe92@gmail.com)
# Desc: You can compile StRoot software by just typing ./compile.sh
#       after that you can find libraries in the ./libs directory.
#       Have fun!
#

# Directories where we want do make
export DIR_TO_MAKE="StarRoot StChain St_base StarClassLibrary StBichsel StEvent StStrangeMuDstMaker StEventUtilities StFemtoDst StHbtMaker StFlowMaker StFemtoEvent"

# Create directory 'libs' and go to StRoot
mkdir libs
mkdir libs_debug
cd StRoot

# Compile all libraries and place them in to 'libs' directory
for i in $DIR_TO_MAKE; do
    cd $i

    export DEBUG_FLAG=""
    make clean && make
    mv *.so ../../libs
    make clean

    export DEBUG_FLAG="-g"
    make clean && make
    mv *.so ../../libs_debug
    make clean

    cd ..
done

echo "Done! :P"
