#include <TFile.h>
#include "TROOT.h"
#include "TSystem.h"
#include "TChain.h"
#include "TTree.h"

//_____________________
void testMaker() {
  //
  // Load libraries
  //
  gSystem->Load("libMinuit");
  gSystem->Load("libTable");
  gSystem->Load("libs/libStarClassLibrary.so");   // *
  gSystem->Load("libs/libSt_base.so");            // *
  gSystem->Load("libs/libStarRoot.so");           // *
  gSystem->Load("libs/libStChain.so");            // *
  gSystem->Load("libs/libStBichsel.so");          // *
  gSystem->Load("libs/libStEvent.so");            // *
  gSystem->Load("libs/libStStangeMuDstMaker.so"); // *
  gSystem->Load("libTestMaker");

  StChain   *chain = 0;
  testMaker *maker = 0;

  //
  // List of member links in the chain
  //
  chain = new StChain("StChain");
  maker = new testMaker();

  chain->Init();

  //
  // Loop over the links in the chain
  //
  int iret = 0;
  int nEvents = 15;
  std::cout << "Entries in chain = " << nEvents << std::endl;

  for(int iev = 0; iev < nEvents; iev++) {
    chain->Clear();
    iret = chain->Make(iev);
    if(iret) {
      std::cout << "Error in Make occured. Error code: " << iret << std::endl;
      std::cout << "iev = " << iev << '\n';
      break;
    } 
  }
  chain->Finish();
  //Cleanup
  delete maker;
  delete chain;
}
